#ifndef TIMER
#define TIMER

//IN this superior class we will make a set of timer related stuff...
//THAT is very nice to have in a 3d environment, so you don't come late for your virtual date ;p

class WATCH
{
private:
	//the watch will have several things to display.
	double minutes; //how many minutes;
	double seconds; //how many seconds since started
	double milliseconds; //how many milliseconds, but it only counts up to 10
	double startTime;
public:
	WATCH()
	{
		minutes=0;
		seconds=0;
		milliseconds=0;
		start=0;
	}
	double returnMilliSeconds();
	double returnMinutes();
	double returnSeconds();
	bool start;
	void startClock();
	void stopClock();
	void tickTock();
	void reset();



};

class BEATBOX
{
public:
	//this class takes a value of bpm, and then has routines to sync it with your program.
	BEATBOX(double bpm);
	BEATBOX();
	void init(double bpm);
	void init();
	void tickTock(); //must run every frame!!
	bool kick(); //returns true if it's time to issue a kick timing happening..
private:
	WATCH watch; //this class uses a normal watch to time the events..
	double kickSecond;
	int times_beaten;
};




class TIMER2 //this timer class takes care of such things as frames per second.
{

public:
	TIMER2()
	{
		fps=0;
		deltaTime=0;
	}
	void calcFps();//calculate the frames per second
	
	inline float retFps() //so, little, yet so inline... :p
	{
		return fps;
	}

	inline float retDelta() //so, little, yet so inline... :p
	{
		return deltaTime;
	}
private:
	float fps; //we offcourse need the frames per second! :)
	float deltaTime; //the time between current and last frame
};

class CLockFps
{
	//this class can lock up, until we like to render..
public:
	CLockFps(int fps);
	bool lockFps(void);
	void setFps(int fps);
	int retFps(void);
protected:
	int fps;
};



extern TIMER2 gTimer;
extern WATCH g_watch;
extern BEATBOX beatbox;

#endif
